config/routes.rb
Rails.application.routes.draw do
  get 'books/index'
  root "articles#index"

  resources :articles do
    resources :comments
  end

  resources :books

  resources :products do
    get 'preview', on: :member
  end
  resources :people

  resources :people, only: [:index, :show, :new, :create]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/article.rb
class Article < ApplicationRecord
  include Visible

  has_many :comments, dependent: :destroy

  validates :title, presence: true
  validates :body, presence: true, length: { minimum: 10 }
end

app/models/author.rb
class Author < ApplicationRecord
  has_many :books, -> { order(year_published: :desc) }
end

app/models/book.rb
class Book < ApplicationRecord
  belongs_to :supplier
  belongs_to :author
  has_many :reviews
  has_and_belongs_to_many :orders, join_table: 'books_orders'

  scope :in_print, -> { where(out_of_print: false) }
  scope :out_of_print, -> { where(out_of_print: true) }
  scope :old, -> { where(year_published: ...50.years.ago.year) }
  scope :out_of_print_and_expensive, -> { out_of_print.where('price > 500') }
  scope :costs_more_than, ->(amount) { where('price > ?', amount) }
end

app/models/category.rb
class Category < ApplicationRecord
end

app/models/comment.rb
class Comment < ApplicationRecord
  include Visible

  belongs_to :article
end

app/models/customer.rb
class Customer < ApplicationRecord
  has_many :orders
  has_many :reviews
end

app/models/order.rb
class Order < ApplicationRecord
  belongs_to :customer
  has_and_belongs_to_many :books, join_table: 'books_orders'

  enum :status, [:shipped, :being_packed, :complete, :cancelled]

  scope :created_before, ->(time) { where(created_at: ...time) }
end

app/models/person.rb
class Person < ApplicationRecord
  validates :name, presence: true
  validates :terms_of_service, acceptance: true
  validates :terms_of_service, acceptance: { message: 'must be abided' }
  validates :terms_of_service, acceptance: { accept: 'yes' }
  validates :eula, acceptance: { accept: ['TRUE', 'accepted'] }
  validates :email, confirmation: true
  validates :email, confirmation: { case_sensitive: false }
  validates :end_date, comparison: { greater_than: :start_date }
  validates :legacy_code, format: { with: /\A[a-zA-Z]+\z/,
    message: "only allows letters" }

    validates_each :name, :surname do |record, attr, value|
      record.errors.add(attr, 'must start with upper case') if /\A[[:lower:]]/.match?(value)
    end

    validates :name, presence: true, length: { minimum: 3 }

end

app/models/product.rb
class Product < ApplicationRecord
  has_many :reviews
end

app/models/review.rb
class Review < ApplicationRecord
  belongs_to :customer
  belongs_to :book

  enum :state, [:not_reviewed, :published, :hidden]
end

app/models/supplier.rb
class Supplier < ApplicationRecord
  has_many :books
  has_many :authors, through: :books
end

app/models/user.rb
class User < ApplicationRecord
  after_initialize do |user|
    puts "You have initialized an object!"
  end

  after_find do |user|
    puts "You have found an object!"
  end

  after_touch do |user|
    puts "You have touched an object"
  end
end


class Article < ApplicationRecord
  after_destroy :log_destroy_action

  def log_destroy_action
    puts 'Article destroyed'
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  def index
    @articles = Article.all
  end

  def show
    @article = Article.find(params[:id])
  end

  def new
    @article = Article.new
  end

  def create
    @article = Article.new(article_params)

    if @article.save
      redirect_to @article
    else
      render :new, status: :unprocessable_entity
    end
  end

  def edit
    @article = Article.find(params[:id])
  end

  def update
    @article = Article.find(params[:id])

    if @article.update(article_params)
      redirect_to @article
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @article = Article.find(params[:id])
    @article.destroy

    redirect_to root_path, status: :see_other
  end

  private

  def article_params
    params.require(:article).permit(:title, :body, :status)
  end
end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  def index
    @books = Book.all
  end

  def update
    @book = Book.find(params[:id])
    if @book.update(book_params)
      redirect_to(@book)
    else
      render :edit, status: :unprocessable_entity
    end
  end

end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  def create
    @article = Article.find(params[:article_id])
    @comment = @article.comments.create(comment_params)
    redirect_to article_path(@article)
  end

  def destroy
    @article = Article.find(params[:article_id])
    @comment = @article.comments.find(params[:id])
    @comment.destroy
    redirect_to article_path(@article), status: :see_other
  end

  private
    def comment_params
      params.require(:comment).permit(:commenter, :body, :status)
    end
end

app/controllers/people_controller.rb
class PeopleController < ApplicationController
  def index
    @people = Person.all
  end

  def show
    @person = Person.find(params[:id])
  end

  def new
    @person = Person.new
  end

  def create
    @person = Person.new(person_params)
    if @person.save
      redirect_to @person
    else
      render :new
    end
  end

  private

  def person_params
    params.require(:person).permit(:name, :age, :email)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/people_helper.rb
module PeopleHelper
end

app/views/articles/_form.html.erb
<%= form_with model: article do |form| %>
<div>
  <%= form.label :status %><br>
  <%= form.select :status, Visible::VALID_STATUSES, selected: article.status || 'public' %>
</div>
  <div>
    <%= form.label :title %><br>
    <%= form.text_field :title %>
    <% article.errors.full_messages_for(:title).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>

  <div>
    <%= form.label :body %><br>
    <%= form.text_area :body %><br>
    <% article.errors.full_messages_for(:body).each do |message| %>
      <div><%= message %></div>
    <% end %>
  </div>


  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/articles/edit.html.erb
<h1>New Article</h1>

<%= render "form", article: @article %>

app/views/articles/index.html.erb
<h1>Articles</h1>

<div>
<%= image_tag "blog.png", {height: 45}  %>
</div>
g
Our blog has <%= Article.public_count %> articles and counting!

<ul>
  <% @articles.each do |article| %>
    <% unless article.archived? %>
      <li>
        <%= link_to article.title, article %>
      </li>
    <% end %>
  <% end %>
</ul>

<%= link_to "New Article", new_article_path %>


<%= stylesheet_link_tag "main", "columns" %>

app/views/articles/new.html.erb
<h1>New Article</h1>

<%= render "form", article: @article %>

app/views/articles/show.html.erb
<h1><%= @article.title %></h1>

<p><%= @article.body %></p>

<ul>
  <li><%= link_to "Edit", edit_article_path(@article) %></li>
  <li><%= link_to "Destroy", article_path(@article), data: {
                    turbo_method: :delete,
                    turbo_confirm: "Are you sure?"
                  } %></li>
</ul>

<h2>Comments</h2>
<%= render @article.comments %>

<h2>Add a comment:</h2>
<%= render 'comments/form' %>

app/views/books/index.html.erb
<h1>Listing Books</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Content</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @books.each do |book| %>
      <tr>
        <td><%= book.title %></td>
        <td><%= book.content %></td>
        <td><%= link_to "Show", book %></td>
        <td><%= link_to "Edit", edit_book_path(book) %></td>
        <td><%= link_to "Destroy", book, data: { turbo_method: :delete, turbo_confirm: "Are you sure?" } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to "New book", new_book_path %>

app/views/comments/_comment.html.erb
<% unless comment.archived? %>
  <p>
    <strong>Commenter:</strong>
    <%= comment.commenter %>
  </p>

  <p>
    <strong>Comment:</strong>
    <%= comment.body %>
  </p>

  <p>
    <%= link_to "Destroy Comment", [comment.article, comment], data: {
                  turbo_method: :delete,
                  turbo_confirm: "Are you sure?"
                } %>
  </p>
<% end %>

app/views/comments/_form.html.erb
<%= form_with model: [ @article, @article.comments.build ] do |form| %>
<p>
  <%= form.label :status %><br>
  <%= form.select :status, Visible::VALID_STATUSES, selected: 'public' %>
</p>

  <p>
    <%= form.label :commenter %><br>
    <%= form.text_field :commenter %>
  </p>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  
  <p>
    <%= form.submit %>
  </p>
<% end %>

app/views/people/index.html.erb
<h1>Listing People</h1>

<table>
  <tr>
    <th>Name</th>
    <th>Age</th>
    <th>Email</th>
    <th></th>
  </tr>

  <% @people.each do |person| %>
    <tr>
      <td><%= person.name %></td>
      <td><%= person.age %></td>
      <td><%= person.email %></td>
      <td><%= link_to 'Show', person_path(person) %></td>
    </tr>
  <% end %>
</table>

<%= link_to 'New Person', new_person_path %>

app/views/people/new.html.erb
<h1>New Person</h1>

<%= form_with(model: @person, local: true) do |form| %>
  <% if @person.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@person.errors.count, "error") %> prohibited this person from being saved:</h2>

      <ul>
      <% @person.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :age %>
    <%= form.number_field :age %>
  </div>

  <div class="field">
    <%= form.label :email %>
    <%= form.email_field :email %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

<%= link_to 'Back', people_path %>

app/views/people/show.html.erb
<h1><%= @person.name %></h1>

<p>
  <strong>Age:</strong>
  <%= @person.age %>
</p>

<p>
  <strong>Email:</strong>
  <%= @person.email %>
</p>

<%= link_to 'Back', people_path %>